%define _mpi openmpi

Summary:        Graph, mesh and hypergraph partitioning library
License:        CeCILL
Group:          Development/C++ 
Name:           scotch
Version:        6.0.4
Release:        %mkrel 3
Url:            https://gforge.inria.fr/projects/scotch/
Source0:        https://gforge.inria.fr/frs/download.php/34618/scotch_%{version}.tar.gz
Source1:        scotch-Makefile.inc.in
Patch0:         scotch_esmumps.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  bison
BuildRequires:  fdupes
BuildRequires:  flex
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gcc-gfortran
BuildRequires:  make
BuildRequires:  openmpi-devel
BuildRequires:  zlib-devel

%description
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. 

%package -n ptscotch-openmpi
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       %{name} = %{version}

%description -n ptscotch-openmpi
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering.

%package -n libscotch0
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       %{name} = %{version}

%description -n libscotch0
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. 

%package -n libscotch-devel
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       scotch-devel = %{version}
Requires:       gcc-gfortran
Requires:       libscotch0 = %{version}

%description -n libscotch-devel
This package contains development libraries for libscotch.

%package -n libscotch-devel-static
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       scotch-devel-static = %{version}
Requires:       libscotch-devel = %{version}

%description -n libscotch-devel-static
This package contains libscotch static libraries.


%package -n libscotch-metis-devel
Summary:        Development libraries for scotch
Group:          Development/C++
Requires:       libscotch-devel = %{version}

%description -n libscotch-metis-devel
This package contains the devel libraries and header file in the case
scotch is used as a replacement of the metis library.


%package -n libptscotch0-openmpi
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       libscotch0 = %{version}

%description -n libptscotch0-openmpi
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. 

%package -n libptscotch-openmpi-devel
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       ptscotch-openmpi-devel = %{version}
Requires:       gcc-gfortran
Requires:       libptscotch0-openmpi = %{version}
Requires:       libscotch-devel = %{version}
Requires:       openmpi-devel

%description -n libptscotch-openmpi-devel
This package contains development libraries for libscotch.

%package -n libptscotch-openmpi-devel-static
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       ptscotch-openmpi-devel-static = %{version}
Requires:       libptscotch-openmpi-devel = %{version}

%description -n libptscotch-openmpi-devel-static
This package contains libscotch static libraries.

%package -n libptscotch-parmetis-openmpi-devel
Summary:        Development libraries for scotch
Group:          Development/C++
Requires:       libptscotch-openmpi-devel = %{version}

%description -n libptscotch-parmetis-openmpi-devel
This package contains the devel libraries and header file in the case
ptscotch is used as a replacement of the parmetis library.



%prep
%setup -q -n scotch_%{version}
cat %SOURCE1 | sed s/@RPMFLAGS@/'%{optflags} -fPIC'/g | sed s/@lib@/'%{_lib}'/g > src/Makefile.inc
%patch0 -p1

set -- *
for i in %_mpi
do
    mkdir ptscotch-$i
    cp -ap "$@" ptscotch-$i
done

%build
cd src/
make %{?_smp_mflags} scotch esmumps
gcc -shared -Wl,-soname=libscotcherr.so.0 -o ../lib/libscotcherr.so.0.0	\
	libscotch/library_error.o
gcc -shared -Wl,-soname=libscotcherrexit.so.0 -o	\
	../lib/libscotcherrexit.so.0.0	libscotch/library_error_exit.o
rm -f libscotch/library_error*.o
gcc -shared -Wl,-soname=libscotch.so.0 -o ../lib/libscotch.so.0.0	\
	libscotch/*.o ../lib/libscotcherr.so.0.0 -lpthread -lgfortran -lz -lrt
gcc -shared -Wl,-soname=libscotchmetis.so.0 -o ../lib/libscotchmetis.so.0.0\
	libscotchmetis/*.o ../lib/libscotch.so.0.0 ../lib/libscotcherr.so.0.0 -lz -lm -lrt
gcc -shared -Wl,-soname=libesmumps.so.0 -o ../lib/libesmumps.so.0.0	\
	esmumps/*.o
cd ..

for i in %_mpi
do
cd ptscotch-$i/src/
make %{?_smp_mflags} ptscotch ptesmumps CCP=/usr/bin/mpicc  \
    CCD=/usr/bin/mpicc 
/usr/bin/mpicc  -shared -Wl,-soname=libptscotcherr.so.0 -o ../lib/libptscotcherr.so.0.0\
	libscotch/library_error.o
/usr/bin/mpicc  -shared -Wl,-soname=libptscotcherrexit.so.0 -o	\
	../lib/libptscotcherrexit.so.0.0  libscotch/library_error_exit.o
rm -f libscotch/library_error*.o
/usr/bin/mpicc  -shared -Wl,-soname=libptscotch.so.0 -o ../lib/libptscotch.so.0.0	\
	libscotch/*.o ../lib/libptscotcherr.so.0.0 -lgfortran -lz 
/usr/bin/mpicc  -shared -Wl,-soname=libptscotchparmetis.so.0 -o	\
	../lib/libptscotchparmetis.so.0.0 libscotchmetis/*.o	\
	../lib/libptscotch.so.0.0 ../lib/libptscotcherr.so.0.0 -lz -lm -lrt
/usr/bin/mpicc  -shared -Wl,-soname=libptesmumps.so.0 -o ../lib/libptesmumps.so.0.0	\
	esmumps/*.o
cd ../..
done

%install
pushd src/
make install prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
popd
pushd lib
	for static_libs in libscotch*.a ; do
		libs=`basename $static_libs .a`
		ln -s $libs.so.0.0 $libs.so.0
		ln -s $libs.so.0.0 $libs.so
	done
	cp -dp libscotch*.so* %{buildroot}%{_libdir}/

	for static_libs in lib*esmumps.a ; do
		libs=`basename $static_libs .a`
		ln -s $libs.so.0.0 $libs.so.0
		ln -s $libs.so.0.0 $libs.so
	done
	cp -dp libesmumps.* %{buildroot}%{_libdir}/
        pushd %{buildroot}%{_libdir}
           ln -s libscotchmetis.a libmetis.a
           ln -s libscotchmetis.so libmetis.so
        popd
popd
cp include/esmumps.h %{buildroot}%{_includedir}/
cp src/libscotchmetis/metis.h %{buildroot}%{_includedir}/

for i in %_mpi
do
cd ptscotch-$i
pushd src/
make install prefix=%{buildroot}%{_libdir}/mpi/gcc/$i libdir=%{buildroot}%{_libdir}/mpi/gcc/$i/%_lib
popd
cd lib
	for static_libs in libptscotch*.a ; do
		libs=`basename $static_libs .a`
		ln -s $libs.so.0.0 $libs.so.0
		ln -s $libs.so.0.0 $libs.so
	done
	cp -dp libptscotch*.so* %{buildroot}%{_libdir}/mpi/gcc/$i/%_lib

	for static_libs in libptesmumps.a ; do
		libs=`basename $static_libs .a`
		ln -s $libs.so.0.0 $libs.so.0
		ln -s $libs.so.0.0 $libs.so
	done
	cp -dp libptesmumps.* %{buildroot}%{_libdir}/mpi/gcc/$i/%_lib
	pushd %{buildroot}%{_libdir}/mpi/gcc/$i/%_lib
          ln -s libptscotchparmetis.a libparmetis.a
          ln -s libptscotchparmetis.so libparmetis.so
	popd

	# We create link in order to have the serial libs available in the
	# same directory of the parallel libs. Many softwares using scotch
        # can't manage different dirs for serial and parallel files during
	# their build process.
	for serial_libs in %{buildroot}%{_libdir}/libscotch*.so \
                           %{buildroot}%{_libdir}/libesmumps*.so ; do
	pushd %{buildroot}%{_libdir}/mpi/gcc/$i/%_lib
		libs=`basename $serial_libs .so`
		ln -s %{_libdir}/$libs.so $libs.so
		ln -s %{_libdir}/$libs.so.0 $libs.so.0
		ln -s %{_libdir}/$libs.so.0.0 $libs.so.0.0
	popd
	done
cd ..
cp -p bin/* %{buildroot}%{_libdir}/mpi/gcc/$i/bin
cp include/esmumps.h %{buildroot}%{_libdir}/mpi/gcc/$i/include
cp src/libscotchmetis/parmetis.h %{buildroot}%{_libdir}/mpi/gcc/$i/include
cd ..
done


# Convert the license files to utf8
pushd doc
iconv -f iso8859-1 -t utf-8 < CeCILL-C_V1-en.txt > CeCILL-C_V1-en.txt.conv
iconv -f iso8859-1 -t utf-8 < CeCILL-C_V1-fr.txt > CeCILL-C_V1-fr.txt.conv
mv -f CeCILL-C_V1-en.txt.conv CeCILL-C_V1-en.txt
mv -f CeCILL-C_V1-fr.txt.conv CeCILL-C_V1-fr.txt
popd

%fdupes -s %{buildroot}%{_bindir}


%post -n libscotch0 -p /sbin/ldconfig
%postun -n libscotch0 -p /sbin/ldconfig

%post -n libptscotch0-openmpi -p /sbin/ldconfig
%postun -n libptscotch0-openmpi -p /sbin/ldconfig


%files
%doc README.txt doc/scotch*.pdf doc/CeCILL-*
%{_bindir}/*
%{_mandir}/man1/*

%files -n ptscotch-openmpi
%doc README.txt  doc/ptscotch*.pdf doc/CeCILL-*
%{_libdir}/mpi/gcc/openmpi/bin/*
%{_libdir}/mpi/gcc/openmpi/share/man/man1/*

%files -n libscotch0
%{_libdir}/libscotch.so.*
%{_libdir}/libscotcherr.so.*
%{_libdir}/libscotcherrexit.so.*
%{_libdir}/libscotchmetis.so.*
%{_libdir}/libesmumps.so.*

%files -n libscotch-devel
%{_libdir}/libscotch.so
%{_libdir}/libscotcherr.so
%{_libdir}/libscotcherrexit.so
%{_libdir}/libscotchmetis.so
%{_libdir}/libesmumps.so
%{_includedir}/*.h
%exclude %{_includedir}/metis.h

%files -n libscotch-metis-devel
%{_libdir}/libmetis.so
%{_includedir}/metis.h

%files -n libscotch-devel-static
%{_libdir}/libscotch.a
%{_libdir}/libscotcherr.a
%{_libdir}/libscotcherrexit.a
%{_libdir}/libscotchmetis.a
%{_libdir}/libesmumps.a
%{_libdir}/libmetis.a

%files -n libptscotch0-openmpi
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotch.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherr.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherrexit.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotchmetis.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotch.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherr.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherrexit.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotchparmetis.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libesmumps.so.*
%{_libdir}/mpi/gcc/openmpi/%_lib/libptesmumps.so.*

%files -n libptscotch-openmpi-devel
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotch.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherr.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherrexit.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotchmetis.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotch.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherr.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherrexit.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotchparmetis.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libesmumps.so
%{_libdir}/mpi/gcc/openmpi/%_lib/libptesmumps.so
%{_libdir}/mpi/gcc/openmpi/include/*.h
%exclude %{_libdir}/mpi/gcc/openmpi/include/parmetis.h

%files -n libptscotch-parmetis-openmpi-devel
%{_libdir}/mpi/gcc/openmpi/%_lib/libparmetis.so
%{_libdir}/mpi/gcc/openmpi/include/parmetis.h

%files -n libptscotch-openmpi-devel-static
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotch.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherr.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libscotcherrexit.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotch.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherr.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotcherrexit.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libptscotchparmetis.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libptesmumps.a
%{_libdir}/mpi/gcc/openmpi/%_lib/libparmetis.a




%changelog
* Fri Dec 02 2016 tmb <tmb> 6.0.4-3.mga6
+ Revision: 1071634
- rebuild for new openmpi

* Wed Feb 17 2016 umeabot <umeabot> 6.0.4-2.mga6
+ Revision: 962762
- Mageia 6 Mass Rebuild

* Thu Nov 26 2015 philippem <philippem> 6.0.4-1.mga6
+ Revision: 906224
- update to 6.0.4

* Wed Sep 30 2015 daviddavid <daviddavid> 6.0.0-4.mga6
+ Revision: 885264
- rebuild for new openmpi 1.10.0

* Wed Oct 15 2014 umeabot <umeabot> 6.0.0-3.mga5
+ Revision: 746565
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 6.0.0-2.mga5
+ Revision: 689076
- Mageia 5 Mass Rebuild

* Fri Nov 29 2013 philippem <philippem> 6.0.0-1.mga4
+ Revision: 554079
- fix requires

* Thu Nov 28 2013 philippem <philippem> 6.0.0-0.mga4
+ Revision: 554001
- imported package scotch

